Scala Standard Library2.13.0 < Back


# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.collection.parallel` - Parallel collections (scala-parallel-collections.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package annotation
  Definition Classes
    scala
-  package beans
  Definition Classes
    scala
-  package collection
  Definition Classes
    scala
-  package compat
  Definition Classes
    scala
-  package concurrent

  This package object contains primitives for concurrent and parallel programming.

  This package object contains primitives for concurrent and parallel programming.

  #### Guide

  A more detailed guide to Futures and Promises, including discussion and examples can be found at http://docs.scala-lang.org/overviews/core/futures.html.

  #### Common Imports

  When working with Futures, you will often find that importing the whole concurrent package is convenient:

      import scala.concurrent._

  When using things like `Future`s, it is often required to have an implicit `ExecutionContext` in scope. The general advice for these implicits are as follows.

  If the code in question is a class or method definition, and no `ExecutionContext` is available, request one from the caller by adding an implicit parameter list:

      def myMethod(myParam: MyType)(implicit ec: ExecutionContext) = …
      //Or
      class MyClass(myParam: MyType)(implicit ec: ExecutionContext) { … }

  This allows the caller of the method, or creator of the instance of the class, to decide which `ExecutionContext` should be used.

  For typical REPL usage and experimentation, importing the global `ExecutionContext` is often desired.

      import scala.concurrent.ExcutionContext.Implicits.global

  #### Specifying Durations

  Operations often require a duration to be specified. A duration DSL is available to make defining these easier:

      import scala.concurrent.duration._
      val d: Duration = 10.seconds

  #### Using Futures For Non-blocking Computation

  Basic use of futures is easy with the factory method on Future, which executes a provided function asynchronously, handing you back a future result of that function without blocking the current thread. In order to create the Future you will need either an implicit or explicit ExecutionContext to be provided:

      import scala.concurrent._
      import ExecutionContext.Implicits.global  // implicit execution context

      val firstZebra: Future[Int] = Future {
        val source = scala.io.Source.fromFile("/etc/dictionaries-common/words")
        source.toSeq.indexOfSlice("zebra")
      }

  #### Avoid Blocking

  Although blocking is possible in order to await results (with a mandatory timeout duration):

      import scala.concurrent.duration._
      Await.result(firstZebra, 10.seconds)

  and although this is sometimes necessary to do, in particular for testing purposes, blocking in general is discouraged when working with Futures and concurrency in order to avoid potential deadlocks and improve performance. Instead, use callbacks or combinators to remain in the future domain:

      val animalRange: Future[Int] = for {
        aardvark <- firstAardvark
        zebra <- firstZebra
      } yield zebra - aardvark

      animalRange.onSuccess {
        case x if x > 500000 => println("It's a long way from Aardvark to Zebra")
      }

  Definition Classes
    scala
-  package io
  Definition Classes
    scala
-  package jdk
  Definition Classes
    scala
-  package math

  The package object `scala.math` contains methods for performing basic numeric operations such as elementary exponential, logarithmic, root and trigonometric functions.

  The package object `scala.math` contains methods for performing basic numeric operations such as elementary exponential, logarithmic, root and trigonometric functions.

  All methods forward to java.lang.Math unless otherwise noted.

  Definition Classes
    scala
  See also

    java.lang.Math

-  package ref
  Definition Classes
    scala
-  package reflect
  Definition Classes
    scala
-  package sys

  The package object `scala.sys` contains methods for reading and altering core aspects of the virtual machine as well as the world outside of it.

  The package object `scala.sys` contains methods for reading and altering core aspects of the virtual machine as well as the world outside of it.

  Definition Classes
    scala
  Since

    2.9

-  package util
  Definition Classes
    scala
- #::
- <:<
- =:=
- Any
- AnyVal
- App
- Array
- Boolean
- Byte
- Char
- Console
- DelayedInit
- Double
- DummyImplicit
- Dynamic
- Enumeration
- Equals
- Float
- Function
- Function0
- Function1
- Function10
- Function11
- Function12
- Function13
- Function14
- Function15
- Function16
- Function17
- Function18
- Function19
- Function2
- Function20
- Function21
- Function22
- Function3
- Function4
- Function5
- Function6
- Function7
- Function8
- Function9
- Int
- Long
- MatchError
- None
- NotImplementedError
- Nothing
- Null
- Option
- PartialFunction
- Predef
- Product
- Product1
- Product10
- Product11
- Product12
- Product13
- Product14
- Product15
- Product16
- Product17
- Product18
- Product19
- Product2
- Product20
- Product21
- Product22
- Product3
- Product4
- Product5
- Product6
- Product7
- Product8
- Product9
- Proxy
- ScalaReflectionException
- SerialVersionUID
- Short
- Singleton
- Some
- Specializable
- StringContext
- Symbol
- Tuple1
- Tuple10
- Tuple11
- Tuple12
- Tuple13
- Tuple14
- Tuple15
- Tuple16
- Tuple17
- Tuple18
- Tuple19
- Tuple2
- Tuple20
- Tuple21
- Tuple22
- Tuple3
- Tuple4
- Tuple5
- Tuple6
- Tuple7
- Tuple8
- Tuple9
- UninitializedError
- UninitializedFieldError
- Unit
- ValueOf
- deprecated
- deprecatedInheritance
- deprecatedName
- deprecatedOverriding
- inline
- language
- languageFeature
- native
- noinline
- specialized
- throws
- transient
- unchecked
- volatile

o

scala

# Console

###

#### object Console extends AnsiColor

Implements functionality for printing Scala values on the terminal. For reading values use StdIn. Also defines constants for marking up text on ANSI terminals.

#### Console Output

Use the print methods to output text.

    scala> Console.printf(
      "Today the outside temperature is a balmy %.1f°C. %<.1f°C beats the previous record of %.1f°C.\n",
      -137.0,
      -135.05)
    Today the outside temperature is a balmy -137.0°C. -137.0°C beats the previous record of -135.1°C.

#### ANSI escape codes

Use the ANSI escape codes for colorizing console output either to STDOUT or STDERR.

    import Console.{GREEN, RED, RESET, YELLOW_B, UNDERLINED}

    object PrimeTest {

      def isPrime(): Unit = {

        val candidate = io.StdIn.readInt().ensuring(_ > 1)

        val prime = (2 to candidate - 1).forall(candidate % _ != 0)

        if (prime)
          Console.println(s"${RESET}${GREEN}yes${RESET}")
        else
          Console.err.println(s"${RESET}${YELLOW_B}${RED}${UNDERLINED}NO!${RESET}")
      }

      def main(args: Array[String]): Unit = isPrime()

    }

$ scala PrimeTest
1234567891
yes
$ scala PrimeTest
56474
NO!

#### IO redefinition

Use IO redefinition to temporarily swap in a different set of input and/or output streams. In this example the stream based method above is wrapped into a function.

    import java.io.{ByteArrayOutputStream, StringReader}

    object FunctionalPrimeTest {

      def isPrime(candidate: Int): Boolean = {

        val input = new StringReader(s"$candidate\n")
        val outCapture = new ByteArrayOutputStream
        val errCapture = new ByteArrayOutputStream

        Console.withIn(input) {
          Console.withOut(outCapture) {
            Console.withErr(errCapture) {
              PrimeTest.isPrime()
            }
          }
        }

        if (outCapture.toByteArray.nonEmpty) // "yes"
          true
        else if (errCapture.toByteArray.nonEmpty) // "NO!"
          false
        else throw new IllegalArgumentException(candidate.toString)
      }

      def main(args: Array[String]): Unit = {
        val primes = (2 to 50) filter (isPrime)
        println(s"First primes: $primes")
      }

    }

$ scala FunctionalPrimeTest
First primes: Vector(2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47)

Source
  Console.scala
Since

  1.0

Linear Supertypes
AnsiColor, AnyRef, Any

Ordering

1. Grouped
2. Alphabetic
3. By Inheritance

Inherited

1. Console
2. AnsiColor
3. AnyRef
4. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
4.  final val BLACK: String("\u001B[30m")

   Foreground color for ANSI black

   Foreground color for ANSI black

   Definition Classes
     AnsiColor
5.  final val BLACK_B: String("\u001B[40m")

   Background color for ANSI black

   Background color for ANSI black

   Definition Classes
     AnsiColor
6.  final val BLINK: String("\u001B[5m")

   ANSI blink

   ANSI blink

   Definition Classes
     AnsiColor
7.  final val BLUE: String("\u001B[34m")

   Foreground color for ANSI blue

   Foreground color for ANSI blue

   Definition Classes
     AnsiColor
8.  final val BLUE_B: String("\u001B[44m")

   Background color for ANSI blue

   Background color for ANSI blue

   Definition Classes
     AnsiColor
9.  final val BOLD: String("\u001B[1m")

   ANSI bold

   ANSI bold

   Definition Classes
     AnsiColor
10.  final val CYAN: String("\u001B[36m")

    Foreground color for ANSI cyan

    Foreground color for ANSI cyan

    Definition Classes
      AnsiColor
11.  final val CYAN_B: String("\u001B[46m")

    Background color for ANSI cyan

    Background color for ANSI cyan

    Definition Classes
      AnsiColor
12.  final val GREEN: String("\u001B[32m")

    Foreground color for ANSI green

    Foreground color for ANSI green

    Definition Classes
      AnsiColor
13.  final val GREEN_B: String("\u001B[42m")

    Background color for ANSI green

    Background color for ANSI green

    Definition Classes
      AnsiColor
14.  final val INVISIBLE: String("\u001B[8m")

    ANSI invisible

    ANSI invisible

    Definition Classes
      AnsiColor
15.  final val MAGENTA: String("\u001B[35m")

    Foreground color for ANSI magenta

    Foreground color for ANSI magenta

    Definition Classes
      AnsiColor
16.  final val MAGENTA_B: String("\u001B[45m")

    Background color for ANSI magenta

    Background color for ANSI magenta

    Definition Classes
      AnsiColor
17.  final val RED: String("\u001B[31m")

    Foreground color for ANSI red

    Foreground color for ANSI red

    Definition Classes
      AnsiColor
18.  final val RED_B: String("\u001B[41m")

    Background color for ANSI red

    Background color for ANSI red

    Definition Classes
      AnsiColor
19.  final val RESET: String("\u001B[0m")

    Reset ANSI styles

    Reset ANSI styles

    Definition Classes
      AnsiColor
20.  final val REVERSED: String("\u001B[7m")

    ANSI reversed

    ANSI reversed

    Definition Classes
      AnsiColor
21.  final val UNDERLINED: String("\u001B[4m")

    ANSI underlines

    ANSI underlines

    Definition Classes
      AnsiColor
22.  final val WHITE: String("\u001B[37m")

    Foreground color for ANSI white

    Foreground color for ANSI white

    Definition Classes
      AnsiColor
23.  final val WHITE_B: String("\u001B[47m")

    Background color for ANSI white

    Background color for ANSI white

    Definition Classes
      AnsiColor
24.  final val YELLOW: String("\u001B[33m")

    Foreground color for ANSI yellow

    Foreground color for ANSI yellow

    Definition Classes
      AnsiColor
25.  final val YELLOW_B: String("\u001B[43m")

    Background color for ANSI yellow

    Background color for ANSI yellow

    Definition Classes
      AnsiColor
26.  final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

27.  def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
    Note

      not specified by SLS as a member of AnyRef

28.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
29.  def equals(arg0: AnyRef): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any
30.  def err: PrintStream

    The default error, can be overridden by `withErr`

31.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
    Note

      not specified by SLS as a member of AnyRef

32.  def flush(): Unit

    Flushes the output stream.

    Flushes the output stream. This function is required when partial output (i.e. output not terminated by a newline character) has to be made visible on the terminal.

33.  final def getClass(): Class[_ <: AnyRef]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
34.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
35.  def in: BufferedReader

    The default input, can be overridden by `withIn`

36.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
37.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
38.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

39.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

40.  def out: PrintStream

    The default output, can be overridden by `withOut`

41.  def print(obj: Any): Unit

    Prints an object to `out` using its `toString` method.

    Prints an object to `out` using its `toString` method.

    obj

      the object to print; may be null.

42.  def printf(text: String, args: Any*): Unit

    Prints its arguments as a formatted string to the default output, based on a string pattern (in a fashion similar to printf in C).

    Prints its arguments as a formatted string to the default output, based on a string pattern (in a fashion similar to printf in C).

    The interpretation of the formatting patterns is described in java.util.Formatter.

    text

      the pattern for formatting the arguments.

    args

      the arguments used to instantiating the pattern.

    Exceptions thrown

      `java.lang.IllegalArgumentException` if there was a problem with the format string or arguments

43.  def println(x: Any): Unit

    Prints out an object to the default output, followed by a newline character.

    Prints out an object to the default output, followed by a newline character.

    x

      the object to print.

44.  def println(): Unit

    Prints a newline character on the default output.

45.  def setErrDirect(err: PrintStream): Unit
    Attributes
      protected
46.  def setInDirect(in: BufferedReader): Unit
    Attributes
      protected
47.  def setOutDirect(out: PrintStream): Unit
    Attributes
      protected
48.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
49.  def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any
50.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
51.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
52.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
53.  def withErr[T](err: OutputStream)(thunk: => T): T

    Sets the default error stream for the duration of execution of one thunk.

    Sets the default error stream for the duration of execution of one thunk.

    err

      the new error stream.

    thunk

      the code to execute with the new error stream active

    returns

      the results of `thunk`

    See also

      `withErr[T](err:PrintStream)(thunk: =>T)`

54.  def withErr[T](err: PrintStream)(thunk: => T): T

    Set the default error stream for the duration of execution of one thunk.

    Set the default error stream for the duration of execution of one thunk.

    err

      the new error stream.

    thunk

      the code to execute with the new error stream active

    returns

      the results of `thunk`

    Example:

    1.     withErr(Console.out) { err.println("This goes to default _out_") }

    See also

      `withErr[T](err:OutputStream)(thunk: =>T)`

55.  def withIn[T](in: InputStream)(thunk: => T): T

    Sets the default input stream for the duration of execution of one thunk.

    Sets the default input stream for the duration of execution of one thunk.

    in

      the new input stream.

    thunk

      the code to execute with the new input stream active

    returns

      the results of `thunk`

    See also

      `withIn[T](reader:Reader)(thunk: =>T)`

56.  def withIn[T](reader: Reader)(thunk: => T): T

    Sets the default input stream for the duration of execution of one thunk.

    Sets the default input stream for the duration of execution of one thunk.

    thunk

      the code to execute with the new input stream active

    returns

      the results of `thunk`

    Example:

    1.     val someFile:Reader = openFile("file.txt")
           withIn(someFile) {
             // Reads a line from file.txt instead of default input
             println(readLine)
           }

    See also

      `withIn[T](in:InputStream)(thunk: =>T)`

57.  def withOut[T](out: OutputStream)(thunk: => T): T

    Sets the default output stream for the duration of execution of one thunk.

    Sets the default output stream for the duration of execution of one thunk.

    out

      the new output stream.

    thunk

      the code to execute with the new output stream active

    returns

      the results of `thunk`

    See also

      `withOut[T](out:PrintStream)(thunk: => T)`

58.  def withOut[T](out: PrintStream)(thunk: => T): T

    Sets the default output stream for the duration of execution of one thunk.

    Sets the default output stream for the duration of execution of one thunk.

    out

      the new output stream.

    thunk

      the code to execute with the new output stream active

    returns

      the results of `thunk`

    Example:

    1.     withOut(Console.err) { println("This goes to default _error_") }

    See also

      `withOut[T](out:OutputStream)(thunk: => T)`

### Inherited from AnsiColor

### Inherited from AnyRef

### Inherited from Any

### Console Output

These methods provide output via the console.

### IO Defaults

These values provide direct access to the standard IO channels

### IO Redefinition

These methods allow substituting alternative streams for the duration of a body of code. Threadsafe by virtue of scala.util.DynamicVariable.

### ANSI Style and Control Codes

### ANSI Black

### ANSI Red

### ANSI Green

### ANSI Yellow

### ANSI Blue

### ANSI Magenta

### ANSI Cyan

### ANSI White

### Ungrouped